/*
 *    Copyright  1996, 1997, 1998, 1999, 2000 by Remco Treffkorn
 *    Distributed under the terms of the Q Public License. Please see
 *    the included file LICENSE.
 */
#include "config.h"

#include <X11/Xos.h>
#include <X11/cursorfont.h>
#include <Xm/Text.h>
#include <Xm/TextF.h>
#include <Xm/MainW.h>
#include <Xm/LabelG.h>
#include <X11/xpm.h>

#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

#include "xmap.h"
#include "debug.h"

void save_geometry(Widget w, char *name)
{
    char bufp[256];
    Position x, y;
    Dimension width, height;

    if (w) {
        XtVaGetValues(w,
                      XmNx, &x,
                      XmNy, &y,
                      XmNwidth, &width,
                      XmNheight, &height,
                      NULL);
        snprintf(bufp, 255, "%dx%d+%d+%d", width, height, x, y);
        WritePrivateProfileString("Layout", name, bufp, inifile);
    }
}

void save_position(Widget w, char *name)
{
    Position x, y;
    char bufp[256];

    if (w) {
        XtVaGetValues(w,
                      XmNx, &x,
                      XmNy, &y,
                      NULL);
        snprintf(bufp, 255, "+%d+%d", x, y);
        WritePrivateProfileString("Layout", name, bufp, inifile);
    }
}

#define COPYSIZE 4096

int copy_file(char *from, char *to)
{
    int i, fdfrom, fdto;
    char cbuf[COPYSIZE];

    if ((fdfrom=open(from, O_RDONLY))==-1) {
            return -2;
    }

    if ((fdto=open(to, O_WRONLY))==-1) {
            close(fdfrom);
            return -3;
    }

    while( (i=read(fdfrom, cbuf, COPYSIZE)) > 0 ) {
            if (write(fdto, cbuf, i)!=i) {
                    i = -1;
                    break;
            }
    }
    close(fdfrom);
    close(fdto);

    return i;   // i is 0 or -1
}
